## xeus 2.4.1

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.8)
project(xeus)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
set(XEUS_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(XEUS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(XEUS_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)

# Versionning
# ===========

# Project version
file(STRINGS "${XEUS_INCLUDE_DIR}/xeus/xeus.hpp" xeus_version_defines
     REGEX "#define XEUS_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xeus_version_defines})
    if(ver MATCHES "#define XEUS_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XEUS_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_VERSION
    ${XEUS_VERSION_MAJOR}.${XEUS_VERSION_MINOR}.${XEUS_VERSION_PATCH})
message(STATUS "xeus version: v${XEUS_VERSION}")

# Binary version
# See the following URL for explanations about the binary versionning
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
file(STRINGS "${XEUS_INCLUDE_DIR}/xeus/xeus.hpp" xeus_version_defines
    REGEX "#define XEUS_BINARY_(CURRENT|REVISION|AGE)")
foreach(ver ${xeus_version_defines})
    if(ver MATCHES "#define XEUS_BINARY_(CURRENT|REVISION|AGE) +([^ ]+)$")
        set(XEUS_BINARY_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_BINARY_VERSION
    ${XEUS_BINARY_CURRENT}.${XEUS_BINARY_REVISION}.${XEUS_BINARY_AGE})
message(STATUS "xeus binary version: v${XEUS_BINARY_VERSION}")

# Build options
# =============

# Compilation options
option(XEUS_DISABLE_ARCH_NATIVE "disable -march=native flag" OFF)
option(XEUS_BUILD_SHARED_LIBS "Build xeus shared library." ON)
option(XEUS_BUILD_STATIC_LIBS "Build xeus static library (default if BUILD_SHARED_LIBS is OFF)." ON)
option(XEUS_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)
option(XEUS_EMSCRIPTEN_WASM_BUILD  "build for wasm via emscripten" OFF)

# Test options
option(XEUS_BUILD_TESTS "xeus test suite" OFF)
option(XEUS_EMSCRIPTEN_WASM_TEST_BUILD "indicate that the wasm build is as test build (will use node as environment)" OFF)

# Static build configuration
# ==========================

if (XEUS_STATIC_DEPENDENCIES)
    set(CPPZMQ_TARGET_NAME cppzmq-static)
    set(OPENSSL_USE_STATIC_LIBS ON CACHE BOOL "Linking statically with OpenSSL")
else()
    set(CPPZMQ_TARGET_NAME cppzmq)
    set(OPENSSL_USE_STATIC_LIBS OFF CACHE BOOL "Not linking statically with OpenSSL")
endif()

# Emscripten wasm build configuration
# ===================================

if(XEUS_EMSCRIPTEN_WASM_BUILD)
    SET(XEUS_BUILD_SHARED_LIBS OFF)
    SET(XEUS_BUILD_STATIC_LIBS ON)
    
    # Tests are run in Node, while production builds in the browser.
    if(XEUS_EMSCRIPTEN_WASM_TEST_BUILD)
       add_compile_definitions(XEUS_EMSCRIPTEN_WASM_TEST_BUILD)
       set(XEUS_EMSCRIPTEN_ENVIRONMENT "node")
    else()
       set(XEUS_EMSCRIPTEN_ENVIRONMENT "web,worker")
    endif()
endif()

# Print build configuration
# ==========================

message(STATUS "XEUS_DISABLE_ARCH_NATIVE:        ${XEUS_DISABLE_ARCH_NATIVE}")
message(STATUS "XEUS_BUILD_SHARED_LIBS:          ${XEUS_BUILD_SHARED_LIBS}")
message(STATUS "XEUS_BUILD_STATIC_LIBS:          ${XEUS_BUILD_STATIC_LIBS}")
message(STATUS "XEUS_STATIC_DEPENDENCIES:        ${XEUS_STATIC_DEPENDENCIES}")  
message(STATUS "XEUS_EMSCRIPTEN_WASM_BUILD:      ${XEUS_EMSCRIPTEN_WASM_BUILD}")
message(STATUS "XEUS_BUILD_TESTS:                ${XEUS_BUILD_TESTS}")  
message(STATUS "XEUS_EMSCRIPTEN_WASM_TEST_BUILD: ${XEUS_EMSCRIPTEN_WASM_TEST_BUILD}")

# Dependencies
# ============

set(nlohmann_json_REQUIRED_VERSION 3.2.0)
set(xtl_REQUIRED_VERSION 0.7)
set(cppzmq_REQUIRED_VERSION 4.4.1)
set(zeromq_REQUIRED_VERSION 4.3.2)

if (NOT TARGET nlohmann_json)
    find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET xtl)
    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
endif ()

# for the wasm / emscripten build no zmq is needed 
if(NOT XEUS_EMSCRIPTEN_WASM_BUILD)
    if (NOT TARGET cppzmq AND NOT TARGET cppzmq-static)
        find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
    endif ()

    if (NOT TARGET libzmq AND NOT TARGET libzmq-static)
        if (WIN32)
            find_package(zeromq ${zeromq_REQUIRED_VERSION} REQUIRED)
        else ()
            find_package(zeromq ${zeromq_REQUIRED_VERSION} QUIET)

            if (NOT ZeroMQ_FOUND)
                message(STATUS "CMake libzmq package not found, trying again with pkg-config")
                find_package(PkgConfig)
                pkg_check_modules(ZeroMQ libzmq>=${zeromq_REQUIRED_VERSION} REQUIRED)
                set(ZeroMQ_VERSION ${PC_LIBZMQ_VERSION})
                find_library(ZeroMQ_LIBRARY NAMES libzmq.so libzmq.dylib libzmq.dll
                     PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
                find_library(ZeroMQ_STATIC_LIBRARY NAMES libzmq-static.a libzmq.a libzmq.dll.a
                     PATHS ${PC_LIBZMQ_LIBDIR} ${PC_LIBZMQ_LIBRARY_DIRS})
                message(STATUS "STATIC_LIBRARY" {ZeroMQ_LIBRARY})
                message(STATUS "STATIC_STATIC_LIBRARY" {ZeroMQ_STATIC_LIBRARY})
             endif ()
        endif ()
    endif ()

    if (NOT DEFINED OPENSSL_LIBRARY)
        set(OPENSSL_ROOT_DIR ${CMAKE_INSTALL_PREFIX})
        find_package(OpenSSL REQUIRED)
    endif ()
endif()

# Source files
# ============

# headers for both zmq and emscripten based server
set(XEUS_HEADERS
    ${XEUS_INCLUDE_DIR}/xeus/xcomm.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xcontrol_messenger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xdebugger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xeus.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xeus_context.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xguid.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xhistory_manager.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xinput.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xinterpreter.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xkernel.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xkernel_configuration.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xlogger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xmessage.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xhelper.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xsystem.hpp
)

# Headers related to the zmq-based server
set(XEUS_HEADERS_ZMQ_SERVER
    ${XEUS_INCLUDE_DIR}/xeus/xauthentication.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xdebugger_base.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xdap_tcp_client.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver_control_main.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xmiddleware.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver_shell_main.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver_zmq.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver_zmq_split.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xzmq_serializer.hpp
)

# Headers related to the emscripten wasm server
set(XEUS_HEADERS_EMSCRIPTEN_WASM_SERVER
    ${XEUS_INCLUDE_DIR}/xeus/xembind.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver_emscripten.hpp
)

if(XEUS_EMSCRIPTEN_WASM_BUILD)
    set(XEUS_HEADERS ${XEUS_HEADERS} 
        ${XEUS_HEADERS_EMSCRIPTEN_WASM_SERVER}
    )
else()
    set(XEUS_HEADERS ${XEUS_HEADERS} 
        ${XEUS_HEADERS_ZMQ_SERVER}
    )
endif()

# Sources only related to the zmq based server
set(XEUS_SOURCES_ZMQ_SERVER
    ${XEUS_SOURCE_DIR}/xauthentication.cpp
    ${XEUS_SOURCE_DIR}/xcontrol.hpp
    ${XEUS_SOURCE_DIR}/xcontrol.cpp
    ${XEUS_SOURCE_DIR}/xdap_tcp_client.cpp
    ${XEUS_SOURCE_DIR}/xdebugger_base.cpp
    ${XEUS_SOURCE_DIR}/xheartbeat.cpp
    ${XEUS_SOURCE_DIR}/xheartbeat.hpp
    ${XEUS_SOURCE_DIR}/xzmq_messenger.hpp
    ${XEUS_SOURCE_DIR}/xzmq_messenger.cpp
    ${XEUS_SOURCE_DIR}/xzmq_serializer.cpp
    ${XEUS_SOURCE_DIR}/xmiddleware.cpp
    ${XEUS_SOURCE_DIR}/xpublisher.cpp
    ${XEUS_SOURCE_DIR}/xpublisher.hpp
    ${XEUS_SOURCE_DIR}/xserver_control_main.cpp
    ${XEUS_SOURCE_DIR}/xserver_shell_main.cpp
    ${XEUS_SOURCE_DIR}/xserver_zmq.cpp
    ${XEUS_SOURCE_DIR}/xserver_zmq_split.cpp
    ${XEUS_SOURCE_DIR}/xshell.hpp
    ${XEUS_SOURCE_DIR}/xshell.cpp
    ${XEUS_SOURCE_DIR}/xtrivial_messenger.hpp
    ${XEUS_SOURCE_DIR}/xtrivial_messenger.cpp
)

# Sources only related to the emscripten wasm server
set(XEUS_SOURCES_EMSCRIPTEN_WASM_SERVER
    ${XEUS_SOURCE_DIR}/xembind.cpp
    ${XEUS_SOURCE_DIR}/xserver_emscripten.cpp
)

# Sources for both emscripten and zmq based server
set(XEUS_SOURCES
    ${XEUS_SOURCE_DIR}/xcomm.cpp
    ${XEUS_SOURCE_DIR}/xcontrol_messenger.cpp
    ${XEUS_SOURCE_DIR}/xdebugger.cpp
    ${XEUS_SOURCE_DIR}/xguid.cpp
    ${XEUS_SOURCE_DIR}/xhistory_manager.cpp
    ${XEUS_SOURCE_DIR}/xinput.cpp
    ${XEUS_SOURCE_DIR}/xin_memory_history_manager.hpp
    ${XEUS_SOURCE_DIR}/xin_memory_history_manager.cpp
    ${XEUS_SOURCE_DIR}/xinterpreter.cpp
    ${XEUS_SOURCE_DIR}/xkernel.cpp
    ${XEUS_SOURCE_DIR}/xkernel_configuration.cpp
    ${XEUS_SOURCE_DIR}/xkernel_core.cpp
    ${XEUS_SOURCE_DIR}/xkernel_core.hpp
    ${XEUS_SOURCE_DIR}/xlogger.cpp
    ${XEUS_SOURCE_DIR}/xlogger_impl.hpp
    ${XEUS_SOURCE_DIR}/xlogger_impl.cpp
    ${XEUS_SOURCE_DIR}/xmessage.cpp
    ${XEUS_SOURCE_DIR}/xhelper.cpp
    ${XEUS_SOURCE_DIR}/xmock_interpreter.cpp
    ${XEUS_SOURCE_DIR}/xmock_interpreter.hpp
    ${XEUS_SOURCE_DIR}/xserver.cpp
    ${XEUS_SOURCE_DIR}/xstring_utils.hpp
    ${XEUS_SOURCE_DIR}/xsystem.cpp
)

if(XEUS_EMSCRIPTEN_WASM_BUILD)
    set(XEUS_SOURCES ${XEUS_SOURCES} 
        ${XEUS_SOURCES_EMSCRIPTEN_WASM_SERVER}
    )
else()
    set(XEUS_SOURCES ${XEUS_SOURCES} 
        ${XEUS_SOURCES_ZMQ_SERVER}
    )
endif()


# Targets and link
# ================

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if (XEUS_STATIC_DEPENDENCIES AND NOT MSVC AND NOT APPLE)
	# Explicitly finds and links with libsodium.a
	# because it is not exported as a dependency by
	# the static build of libzmq. Remove this when
	# it is fixed upstream.
	set(sodium_USE_STATIC_LIBS ON)
	find_package(sodium REQUIRED)
endif ()

macro(xeus_create_target target_name linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    # Output
    # ======

    add_library(${target_name} ${linkage_upper} ${XEUS_SOURCES} ${XEUS_HEADERS})

    target_include_directories(
        ${target_name}
        PUBLIC $<BUILD_INTERFACE:${XEUS_INCLUDE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    if(NOT XEUS_EMSCRIPTEN_WASM_BUILD)  
        target_link_libraries(
            ${target_name}
            PUBLIC ${CPPZMQ_TARGET_NAME}
            PUBLIC nlohmann_json::nlohmann_json
            PUBLIC xtl
        )
        target_link_libraries(${target_name} PUBLIC OpenSSL::Crypto)
    else()
        target_link_libraries(
            ${target_name}
            PUBLIC nlohmann_json::nlohmann_json
            PUBLIC xtl
        )
    endif()

    if (NOT MSVC AND NOT XEUS_EMSCRIPTEN_WASM_BUILD)
        if (APPLE)
            target_link_libraries(${target_name} PUBLIC "-framework CoreFoundation")
        else ()
            if (XEUS_STATIC_DEPENDENCIES)
                find_path(LIBUUID_INCLUDE_DIR uuid.h PATH_SUFFIXES uuid)
                find_library(LIBUUID_LIBRARY libuuid.a)
                target_include_directories(${target_name} PRIVATE ${LIBUUID_INCLUDE_DIR})
                target_link_libraries(${target_name} PUBLIC ${LIBUUID_LIBRARY})

=== example/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.4.3)
project(my_kernel)

set(EXECUTABLE_NAME my_kernel)

# Configuration
# =============

include(GNUInstallDirs)

# We generate the kernel.json file, given the installation prefix and the executable name
configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/my_kernel/kernel.json.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/my_kernel/kernel.json"
)

option(XEUS_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)
if (XEUS_STATIC_DEPENDENCIES)
    set(xeus_target "xeus-static")
else ()
    set(xeus_target "xeus")
endif ()

# Dependencies
# ============

# Be sure to use recent versions
set(xeus_REQUIRED_VERSION 0.19.1)
set(cppzmq_REQUIRED_VERSION 4.3.0)

find_package(xeus ${xeus_REQUIRED_VERSION} REQUIRED)
find_package(cppzmq ${cppzmq_REQUIRED_VERSION} REQUIRED)
find_package(Threads)

# Flags
# =====

include(CheckCXXCompilerFlag)

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else()
        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++14 support!")
    endif()
endif()

# Target and link
# ===============

# my_kernel source files
set(MY_KERNEL_SRC
    src/custom_interpreter.cpp
    src/custom_interpreter.hpp
)

# My kernel executable
add_executable(${EXECUTABLE_NAME} src/main.cpp ${MY_KERNEL_SRC} )
target_link_libraries(${EXECUTABLE_NAME} PRIVATE ${xeus_target} Threads::Threads)

set_target_properties(${EXECUTABLE_NAME} PROPERTIES
    INSTALL_RPATH_USE_LINK_PATH TRUE
)

# Installation
# ============

# Install my_kernel
install(TARGETS ${EXECUTABLE_NAME}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Configuration and data directories for jupyter and my_kernel
set(XJUPYTER_DATA_DIR "share/jupyter" CACHE STRING "Jupyter data directory")

# Install Jupyter kernelspecs
set(MY_KERNELSPEC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels)
install(DIRECTORY ${MY_KERNELSPEC_DIR}
        DESTINATION ${XJUPYTER_DATA_DIR}
        PATTERN "*.in" EXCLUDE)

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Sylvain Corlay, Johan Mabille, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

# Unit tests
# ==========
if(NOT XEUS_EMSCRIPTEN_WASM_BUILD)
    cmake_minimum_required(VERSION 3.1)

    if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
        project(xeus-test)

        enable_testing()

        find_package(xeus REQUIRED CONFIG)
        find_package(nlohmann_json QUIET CONFIG)

        set(XEUS_TEST_DIR ${CMAKE_CURRENT_LIST_DIR})
    endif ()

    message(STATUS "Forcing tests build type to Release")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

    include(CheckCXXCompilerFlag)

    string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

    if(nlohmann_json_FOUND)
      add_definitions(-DHAVE_NLOHMANN_JSON)
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES Clang OR CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
        add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

        CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
        if (HAS_MARCH_NATIVE)
            add_compile_options(-march=native)
        endif()
    endif()

    if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
        add_compile_options(/EHsc /MP /bigobj)
        set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
    endif()


    find_package(doctest REQUIRED)


    find_package(Threads)

    find_program(PYTEST  
        NAMES pytest-3 pytest py.test-3 py.test REQUIRED)


    set(XEUS_TESTS
        test_xin_memory_history_manager.cpp
        test_unit_kernel.cpp
    )

    if(nlohmann_json_FOUND)
        # Version up to 3.1.2 export the target `nlohmann_json`
        if(TARGET nlohmann_json)
          set(nlohmann_json_TARGET nlohmann_json)
        # Newer versions export the namespaced target `nlohmann_json::nlohmann_json`
        elseif(TARGET nlohmann_json::nlohmann_json)
          set(nlohmann_json_TARGET nlohmann_json::nlohmann_json)
        endif()
    endif()

    if (TARGET xeus)
        set(xeus_TARGET xeus)
        message("Found xeus shared library.")
    elseif (TARGET xeus-static)
        set(xeus_TARGET xeus-static)
        message("Found xeus static library.")
    endif ()

    foreach(filename IN LISTS XEUS_TESTS)
        get_filename_component(targetname ${filename} NAME_WE)

        add_executable(${targetname} test_main.cpp ${filename} test_interpreter.cpp)
        target_link_libraries(${targetname} PRIVATE ${xeus_TARGET} doctest::doctest Threads::Threads ${nlohmann_json_TARGET})
        add_test(NAME ${targetname} COMMAND ${targetname})
    endforeach()


    # Test_kernel tests
    # =================

    set(TEST_KERNEL_SOURCES
        test_interpreter.cpp
        test_interpreter.hpp
        main.cpp)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel/kernel.json.in"
        "kernels/test_kernel/kernel.json"
    )

    add_executable(test_kernel ${TEST_KERNEL_SOURCES})
    target_link_libraries(test_kernel PRIVATE ${xeus_TARGET} Threads::Threads)
    target_compile_features(test_kernel PRIVATE cxx_std_11)

    set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel.py"
        "${CMAKE_CURRENT_BINARY_DIR}/"
        COPYONLY)

    add_test(NAME test_kernel
        COMMAND ${PYTEST} test_kernel.py)
    set_tests_properties(test_kernel
        PROPERTIES
        ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")

    # Test_kernel_control tests
    # =========================

    set(TEST_KERNEL_SPLIT_SOURCES
        test_interpreter.cpp
        test_interpreter.hpp
        main_control.cpp)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel_control/kernel.json.in"
        "kernels/test_kernel_control/kernel.json"
    )

    add_executable(test_kernel_control ${TEST_KERNEL_SPLIT_SOURCES})
    target_link_libraries(test_kernel_control PRIVATE ${xeus_TARGET} Threads::Threads)
    target_compile_features(test_kernel_control PRIVATE cxx_std_11)

    set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel_control.py"
        "${CMAKE_CURRENT_BINARY_DIR}/"
        COPYONLY)

    add_test(NAME test_kernel_control
        COMMAND ${PYTEST} test_kernel_control.py)
    set_tests_properties(test_kernel_control
        PROPERTIES
        ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")

    # Test_kernel_shell tests
    # =======================

    set(TEST_KERNEL_SPLIT_SOURCES
        test_interpreter.cpp
        test_interpreter.hpp
        main_shell.cpp)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel_shell/kernel.json.in"
        "kernels/test_kernel_shell/kernel.json"
    )

    add_executable(test_kernel_shell ${TEST_KERNEL_SPLIT_SOURCES})
    target_link_libraries(test_kernel_shell PRIVATE ${xeus_TARGET} Threads::Threads)
    target_compile_features(test_kernel_shell PRIVATE cxx_std_11)

    set(CONNECTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/connection.json)

    configure_file(
        "${XEUS_TEST_DIR}/test_kernel_shell.py"
        "${CMAKE_CURRENT_BINARY_DIR}/"
        COPYONLY)

    add_test(NAME test_kernel_shell
        COMMAND ${PYTEST} test_kernel_shell.py)
    set_tests_properties(test_kernel_shell
        PROPERTIES
        ENVIRONMENT "JUPYTER_PATH=${CMAKE_CURRENT_BINARY_DIR}")
else()
    add_executable(emscripten_wasm_test main_emscripten_wasm.cpp test_interpreter.cpp)
    target_link_libraries(emscripten_wasm_test PRIVATE xeus-static)
endif()

=== debian/changelog ===
xeus (2.4.1-1) unstable; urgency=medium

  * New upstream version 2.4.1
  * Upload to unstable
  * Closes: #1019992

 -- Gordon Ball <gordon@chronitis.net>  Sat, 01 Oct 2022 17:45:34 +0000

xeus (2.4.0-2) experimental; urgency=medium

  [ Stephan Lachnit ]
  * Depend on cppzmq-dev instead of libzmq3-dev for zmq.hpp, and drop the
    patch required for missing cppzmq cmake files in libzmq3-dev

 -- Gordon Ball <gordon@chronitis.net>  Sat, 27 Aug 2022 21:37:35 +0200

xeus (2.4.0-1) experimental; urgency=medium

  * New upstream version 2.4.0

 -- Gordon Ball <gordon@chronitis.net>  Mon, 14 Mar 2022 22:03:36 +0000

xeus (2.3.1-1) experimental; urgency=medium

  * Drop debian/patches/0004-Keep-support-for-cppzmq-4.6.0.patch (updated in
    src:zeromq3 4.3.4-2)
  * New upstream version 2.3.1
  * Rebase patches
  * Standards-Version: 4.6.0

 -- Gordon Ball <gordon@chronitis.net>  Tue, 25 Jan 2022 19:16:10 +0000

xeus (2.1.1-1) experimental; urgency=medium

  * New upstream version 2.1.1
  * Add b-d on doctest-dev
  * Rename libxeus1 -> libxeus6 for soversion 6

 -- Gordon Ball <gordon@chronitis.net>  Wed, 13 Oct 2021 19:45:42 +0000

=== debian/control ===
Source: xeus
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               cmake,
               cppzmq-dev,
               xtl-dev (>= 0.7~),
               nlohmann-json3-dev,
               uuid-dev,
               libssl-dev,
               pkg-config,
               googletest <!nocheck>,
               doctest-dev,
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/jupyter-xeus/xeus
Vcs-Git: https://salsa.debian.org/science-team/xeus.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus
Rules-Requires-Root: no

Package: libxeus6
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Implementation of the Jupyter Kernel protocol (library)
 xeus enables custom kernel authors to implement Jupyter kernels more
 easily. It takes the burden of implementing the Jupyter Kernel protocol
 so developers can focus on implementing the interpreter part of the Kernel.
 .
 This package contains the shared library.

Package: xeus-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libxeus6 (= ${binary:Version}),
         xtl-dev,
         cppzmq-dev,
         nlohmann-json3-dev,
         uuid-dev,
         libssl-dev,
Description: C++ Implementation of the Jupyter Kernel protocol (headers)
 xeus enables custom kernel authors to implement Jupyter kernels more
 easily. It takes the burden of implementing the Jupyter Kernel protocol
 so developers can focus on implementing the interpreter part of the Kernel.
 .
 This package contains the headers and cmake config.

## xeus 3.1.1

=== debian/changelog ===
xeus (3.1.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:03:41 +0000

xeus (3.1.1-1) experimental; urgency=medium

  [ Debian Janitor ]
  * Mark debian/rules as executable.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Gordon Ball ]
  * New upstream version 3.1.1
  * Rebase patches
  * Drop cppzmq dependency (moved to xeus-zmq)
  * Bump soversion libxeus6 -> libxeus9
  * Drop unused dependency on googletest

 -- Gordon Ball <gordon@chronitis.net>  Fri, 28 Jul 2023 15:49:19 +0000

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,20 @@
 Uploaders: Gordon Ball <gordon@chronitis.net>
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               cppzmq-dev,
                xtl-dev (>= 0.7~),
                nlohmann-json3-dev,
                uuid-dev,
                libssl-dev,
                pkg-config,
-               googletest <!nocheck>,
                doctest-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Section: libs
 Homepage: https://github.com/jupyter-xeus/xeus
 Vcs-Git: https://salsa.debian.org/science-team/xeus.git
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus6
+Package: libxeus9
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ Implementation of the Jupyter Kernel protocol (library)
@@ -33,9 +31,8 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus6 (= ${binary:Version}),
+         libxeus9 (= ${binary:Version}),
          xtl-dev,
-         cppzmq-dev,
          nlohmann-json3-dev,
          uuid-dev,
          libssl-dev,

## xeus 3.1.3

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Johan Mabille, Sylvain Corlay, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.8)
project(xeus)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
set(XEUS_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(XEUS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(XEUS_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)

# Versionning
# ===========

# Project version
file(STRINGS "${XEUS_INCLUDE_DIR}/xeus/xeus.hpp" xeus_version_defines
     REGEX "#define XEUS_VERSION_(MAJOR|MINOR|PATCH)")
foreach(ver ${xeus_version_defines})
    if(ver MATCHES "#define XEUS_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XEUS_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_VERSION
    ${XEUS_VERSION_MAJOR}.${XEUS_VERSION_MINOR}.${XEUS_VERSION_PATCH})
message(STATUS "xeus version: v${XEUS_VERSION}")

# Binary version
# See the following URL for explanations about the binary versionning
# https://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html#Updating-version-info
file(STRINGS "${XEUS_INCLUDE_DIR}/xeus/xeus.hpp" xeus_version_defines
    REGEX "#define XEUS_BINARY_(CURRENT|REVISION|AGE)")
foreach(ver ${xeus_version_defines})
    if(ver MATCHES "#define XEUS_BINARY_(CURRENT|REVISION|AGE) +([^ ]+)$")
        set(XEUS_BINARY_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif()
endforeach()
set(XEUS_BINARY_VERSION
    ${XEUS_BINARY_CURRENT}.${XEUS_BINARY_REVISION}.${XEUS_BINARY_AGE})
message(STATUS "xeus binary version: v${XEUS_BINARY_VERSION}")

# Build options
# =============

# Compilation options
option(XEUS_BUILD_SHARED_LIBS "Build xeus shared library." ON)
option(XEUS_BUILD_STATIC_LIBS "Build xeus static library (default if BUILD_SHARED_LIBS is OFF)." ON)
option(XEUS_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)
option(XEUS_EMSCRIPTEN_WASM_BUILD  "build for wasm via emscripten" OFF)

# Test options
option(XEUS_BUILD_TESTS "xeus test suite" OFF)

# Emscripten wasm build configuration
# ===================================

if(XEUS_EMSCRIPTEN_WASM_BUILD)
    SET(XEUS_BUILD_SHARED_LIBS OFF)
    SET(XEUS_BUILD_STATIC_LIBS ON)
endif()

# Print build configuration
# ==========================

message(STATUS "XEUS_BUILD_SHARED_LIBS:          ${XEUS_BUILD_SHARED_LIBS}")
message(STATUS "XEUS_BUILD_STATIC_LIBS:          ${XEUS_BUILD_STATIC_LIBS}")
message(STATUS "XEUS_STATIC_DEPENDENCIES:        ${XEUS_STATIC_DEPENDENCIES}")  
message(STATUS "XEUS_EMSCRIPTEN_WASM_BUILD:      ${XEUS_EMSCRIPTEN_WASM_BUILD}")
message(STATUS "XEUS_BUILD_TESTS:                ${XEUS_BUILD_TESTS}")  

# Dependencies
# ============

set(nlohmann_json_REQUIRED_VERSION 3.2.0)
set(xtl_REQUIRED_VERSION 0.7)

if (NOT TARGET nlohmann_json)
    find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
endif ()

if (NOT TARGET xtl)
    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
endif ()

# Source files
# ============

set(XEUS_HEADERS
    ${XEUS_INCLUDE_DIR}/xeus/xcomm.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xcontrol_messenger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xdebugger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xeus.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xeus_context.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xguid.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xhistory_manager.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xinput.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xinterpreter.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xkernel.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xkernel_configuration.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xlogger.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xmessage.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xhelper.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xserver.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xstring_utils.hpp
    ${XEUS_INCLUDE_DIR}/xeus/xsystem.hpp
)

set(XEUS_SOURCES
    ${XEUS_SOURCE_DIR}/xcomm.cpp
    ${XEUS_SOURCE_DIR}/xcontrol_messenger.cpp
    ${XEUS_SOURCE_DIR}/xdebugger.cpp
    ${XEUS_SOURCE_DIR}/xguid.cpp
    ${XEUS_SOURCE_DIR}/xhistory_manager.cpp
    ${XEUS_SOURCE_DIR}/xinput.cpp
    ${XEUS_SOURCE_DIR}/xin_memory_history_manager.hpp
    ${XEUS_SOURCE_DIR}/xin_memory_history_manager.cpp
    ${XEUS_SOURCE_DIR}/xinterpreter.cpp
    ${XEUS_SOURCE_DIR}/xkernel.cpp
    ${XEUS_SOURCE_DIR}/xkernel_configuration.cpp
    ${XEUS_SOURCE_DIR}/xkernel_core.cpp
    ${XEUS_SOURCE_DIR}/xkernel_core.hpp
    ${XEUS_SOURCE_DIR}/xlogger.cpp
    ${XEUS_SOURCE_DIR}/xlogger_impl.hpp
    ${XEUS_SOURCE_DIR}/xlogger_impl.cpp
    ${XEUS_SOURCE_DIR}/xmessage.cpp
    ${XEUS_SOURCE_DIR}/xhelper.cpp
    ${XEUS_SOURCE_DIR}/xmock_interpreter.cpp
    ${XEUS_SOURCE_DIR}/xmock_interpreter.hpp
    ${XEUS_SOURCE_DIR}/xserver.cpp
    ${XEUS_SOURCE_DIR}/xsystem.cpp
)

# Targets and link
# ================

include(CheckCXXCompilerFlag)

include(cmake/CompilerWarnings.cmake)
include(WasmBuildOptions)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

macro(xeus_create_target target_name linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    # Output
    # ======

    add_library(${target_name} ${linkage_upper} ${XEUS_SOURCES} ${XEUS_HEADERS})

    target_include_directories(
        ${target_name}
        PUBLIC $<BUILD_INTERFACE:${XEUS_INCLUDE_DIR}>
        $<INSTALL_INTERFACE:include>
    )

    target_link_libraries(
        ${target_name}
        PUBLIC nlohmann_json::nlohmann_json
        PUBLIC xtl
    )

    if (NOT MSVC AND NOT XEUS_EMSCRIPTEN_WASM_BUILD)
        if (APPLE)
            target_link_libraries(${target_name} PUBLIC "-framework CoreFoundation")
        else ()
            if (XEUS_STATIC_DEPENDENCIES)
                find_path(LIBUUID_INCLUDE_DIR uuid/uuid.h)
                find_library(LIBUUID_LIBRARY libuuid.a)
                target_include_directories(${target_name} PRIVATE ${LIBUUID_INCLUDE_DIR})
                target_link_libraries(${target_name} PRIVATE ${LIBUUID_LIBRARY}) 
            else ()
                find_package(LibUUID REQUIRED)
                target_link_libraries(${target_name} PRIVATE LibUUID::LibUUID)
            endif ()
        endif ()
    endif ()

    if (UNIX)
        # CMake does not compute the version number of so files as libtool
        # does on Linux. Strictly speaking, we should exclude FreeBSD and
        # Apple from this, but that would require having different version
        # numbers depending on the platform. We prefer to follow the
        # libtool pattern everywhere.
        math(EXPR XEUS_BINARY_COMPATIBLE "${XEUS_BINARY_CURRENT} - ${XEUS_BINARY_AGE}")
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_HEADERS}"
            COMPILE_OPTIONS "-fvisibility=hidden"
            COMPILE_DEFINITIONS "XEUS_EXPORTS"
            PREFIX ""
            VERSION "${XEUS_BINARY_COMPATIBLE}.${XEUS_BINARY_REVISION}.${XEUS_BINARY_AGE}"
            SOVERSION ${XEUS_BINARY_COMPATIBLE}
            OUTPUT_NAME "lib${output_name}"
        )
    else()
        set_target_properties(
            ${target_name}
            PROPERTIES
            PUBLIC_HEADER "${XEUS_HEADERS}"
            COMPILE_DEFINITIONS "XEUS_EXPORTS"
            PREFIX ""
            VERSION ${XEUS_BINARY_VERSION}
            SOVERSION ${XEUS_BINARY_CURRENT}
            OUTPUT_NAME "lib${output_name}"
        )
    endif()

    # Compilation flags
    # =================

    target_compile_features(${target_name} PRIVATE cxx_std_14)
    xeus_target_add_compile_warnings(${target_name})

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
        CMAKE_CXX_COMPILER_ID MATCHES "Intel")
        message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
    endif()

    if (${linkage_upper} STREQUAL "STATIC")
        target_compile_definitions(${target_name} PUBLIC XEUS_STATIC_LIB)
    endif ()

    if (MSVC)
        target_compile_definitions(${target_name} PUBLIC -DNOMINMAX)
        target_compile_options(${target_name} PUBLIC /DGUID_WINDOWS /MP /bigobj)
        target_compile_options(${target_name} PUBLIC /wd4251 /wd4996)
    elseif (APPLE)
        target_compile_definitions(${target_name} PUBLIC -DGUID_CFUUID)
    else ()
        target_compile_definitions(${target_name} PUBLIC -DGUID_LIBUUID)
    endif ()

    if (XEUS_STATIC_DEPENDENCIES)
        if (CMAKE_DL_LIBS)
            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS})
        endif ()
        if (UNIX AND NOT APPLE)
            target_link_libraries(${target_name} PRIVATE util rt)
        endif ()
    endif ()

    if (XEUS_EMSCRIPTEN_WASM_BUILD)
       target_compile_definitions(${target_name} PRIVATE XEUS_EMSCRIPTEN_WASM_BUILD)
       xeus_wasm_compile_options(${target_name})
    endif()
endmacro()

set(xeus_targets "")

if (XEUS_BUILD_SHARED_LIBS)
    xeus_create_target(xeus SHARED xeus)
    list(APPEND xeus_targets xeus)
endif ()

if (XEUS_BUILD_STATIC_LIBS)
    # On Windows, a static library should use a different output name
    # to avoid the conflict with the import library of a shared one.
    if (CMAKE_HOST_WIN32)
        xeus_create_target(xeus-static STATIC xeus-static)
    else ()
        xeus_create_target(xeus-static STATIC xeus)
    endif ()

    list(APPEND xeus_targets xeus-static)
endif ()

# Tests
# =====

# We need to control from outside whether we enable testing or not. We cannot
# rely on BUILD_TESTING since it doe snot exist until CTest is included.

include(CTest)

if(XEUS_BUILD_TESTS)
    set(BUILD_TESTING ON)
    message(STATUS "tests enabled")
else ()
    set(BUILD_TESTING OFF)
    message(STATUS "tests disabled")
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

# Installation
# ============

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(XEUS_CMAKECONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE STRING "install path for xeusConfig.cmake")

install(TARGETS ${xeus_targets}
        EXPORT ${PROJECT_NAME}-targets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/xeus)

# Makes the project importable from the build directory
export(EXPORT ${PROJECT_NAME}-targets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake")

# Configure 'xeusConfig.cmake' for a build tree
set(XEUS_CONFIG_CODE "####### Expanded from \@XEUS_CONFIG_CODE\@ #######\n")
set(XEUS_CONFIG_CODE "${XEUS_CONFIG_CODE}set(CMAKE_MODULE_PATH \"${CMAKE_CURRENT_SOURCE_DIR}/cmake;\${CMAKE_MODULE_PATH}\")\n")
set(XEUS_CONFIG_CODE "${XEUS_CONFIG_CODE}##################################################")
configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${PROJECT_BINARY_DIR})

# Configure 'xeusConfig.cmake' for an install tree
set(XEUS_CONFIG_CODE "")
configure_package_config_file(${PROJECT_NAME}Config.cmake.in
                              "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}Config.cmake"
                              INSTALL_DESTINATION ${XEUS_CMAKECONFIG_INSTALL_DIR})


write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Sylvain Corlay, Johan Mabille, Martin Renou          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

# Unit tests
# ==========
cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xeus-test)

    enable_testing()

    find_package(xeus REQUIRED CONFIG)
    find_package(nlohmann_json QUIET CONFIG)

    set(XEUS_TEST_DIR ${CMAKE_CURRENT_LIST_DIR})
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

if(nlohmann_json_FOUND)
  add_definitions(-DHAVE_NLOHMANN_JSON)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES Clang OR CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
    add_compile_options(/EHsc /MP /bigobj)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

find_package(doctest REQUIRED)
find_package(Threads)

set(XEUS_TESTS
    test_xin_memory_history_manager.cpp
    test_unit_kernel.cpp
)

if(nlohmann_json_FOUND)
    # Version up to 3.1.2 export the target `nlohmann_json`
    if(TARGET nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json)
    # Newer versions export the namespaced target `nlohmann_json::nlohmann_json`
    elseif(TARGET nlohmann_json::nlohmann_json)
      set(nlohmann_json_TARGET nlohmann_json::nlohmann_json)
    endif()
endif()

if (TARGET xeus)
    set(xeus_TARGET xeus)
    message("Found xeus shared library.")
elseif (TARGET xeus-static)
    set(xeus_TARGET xeus-static)
    message("Found xeus static library.")
endif ()

set(XEUS_TEST_SRCS
    xmock_interpreter.hpp
    xmock_interpreter.cpp
    xmock_server.hpp
    xmock_server.cpp)

foreach(filename IN LISTS XEUS_TESTS)
    get_filename_component(targetname ${filename} NAME_WE)

    add_executable(${targetname} test_main.cpp ${filename} ${XEUS_TEST_SRCS})
    target_link_libraries(${targetname} PRIVATE ${xeus_TARGET} doctest::doctest Threads::Threads ${nlohmann_json_TARGET})
    add_test(NAME ${targetname} COMMAND ${targetname})
endforeach()

=== debian/changelog ===
xeus (3.1.3-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3
    The API of this library exposes types from nlohmann::json, and this
    resulted in an ABI change depending on whether libxeus and the kernel
    are built against 3.11.2 or 3.11.3. This adds an explicit dependency
    on nlohmann-json3-dev 3.11.3. This explicitly chooses the newer version
    for libxeus and dependencies. (Closes: #1060164, #1061007)

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:12:56 +0100

xeus (3.1.3-1) unstable; urgency=medium

  * New upstream version 3.1.3

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 10:30:56 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                xtl-dev (>= 0.7~),
-               nlohmann-json3-dev,
+               nlohmann-json3-dev (>= 3.11.3~),
                uuid-dev,
                libssl-dev,
                pkg-config,
@@ -33,7 +33,7 @@
 Depends: ${misc:Depends},
          libxeus9 (= ${binary:Version}),
          xtl-dev,
-         nlohmann-json3-dev,
+         nlohmann-json3-dev (>= 3.11.3~),
          uuid-dev,
          libssl-dev,
 Description: C++ Implementation of the Jupyter Kernel protocol (headers)

## xeus 5.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,6 @@
 option(XEUS_BUILD_SHARED_LIBS "Build xeus shared library." ON)
 option(XEUS_BUILD_STATIC_LIBS "Build xeus static library (default if BUILD_SHARED_LIBS is OFF)." ON)
 option(XEUS_STATIC_DEPENDENCIES "link statically with xeus dependencies" OFF)
-option(XEUS_EMSCRIPTEN_WASM_BUILD  "build for wasm via emscripten" OFF)
 
 # Test options
 option(XEUS_BUILD_TESTS "xeus test suite" OFF)
@@ -59,7 +58,7 @@
 # Emscripten wasm build configuration
 # ===================================
 
-if(XEUS_EMSCRIPTEN_WASM_BUILD)
+if(EMSCRIPTEN)
     SET(XEUS_BUILD_SHARED_LIBS OFF)
     SET(XEUS_BUILD_STATIC_LIBS ON)
 endif()
@@ -70,36 +69,41 @@
 message(STATUS "XEUS_BUILD_SHARED_LIBS:          ${XEUS_BUILD_SHARED_LIBS}")
 message(STATUS "XEUS_BUILD_STATIC_LIBS:          ${XEUS_BUILD_STATIC_LIBS}")
 message(STATUS "XEUS_STATIC_DEPENDENCIES:        ${XEUS_STATIC_DEPENDENCIES}")  
-message(STATUS "XEUS_EMSCRIPTEN_WASM_BUILD:      ${XEUS_EMSCRIPTEN_WASM_BUILD}")
+message(STATUS "XEUS_EMSCRIPTEN_WASM_BUILD:      ${EMSCRIPTEN}")
 message(STATUS "XEUS_BUILD_TESTS:                ${XEUS_BUILD_TESTS}")  
 
 # Dependencies
 # ============
 
-set(nlohmann_json_REQUIRED_VERSION 3.2.0)
-set(xtl_REQUIRED_VERSION 0.7)
+# nlohmann_json requires libraries that exchange json objects to be linked
+# with the same version of nlohmann_json. Therefore this version should be
+# the same in all xeus components; to do so, downstream projects should not
+# search # directly for nlohmann_json, but rely on find_dependency called by
+# find_package(xeus) instead.
+set(nlohmann_json_REQUIRED_VERSION 3.11)
 
 if (NOT TARGET nlohmann_json)
     find_package(nlohmann_json ${nlohmann_json_REQUIRED_VERSION} REQUIRED)
-endif ()
-
-if (NOT TARGET xtl)
-    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
+    message(STATUS "Found nlohmann_json ${nlohmann_json_VERSION}")
 endif ()
 
 # Source files
 # ============
 
 set(XEUS_HEADERS
+    ${XEUS_INCLUDE_DIR}/xeus/xbase64.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xbasic_fixed_string.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xcomm.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xcontrol_messenger.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xdebugger.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xeus.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xeus_context.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xguid.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xhash.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xhistory_manager.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xinput.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xinterpreter.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xjson.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xkernel.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xkernel_configuration.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xlogger.hpp
@@ -108,6 +112,7 @@
     ${XEUS_INCLUDE_DIR}/xeus/xserver.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xstring_utils.hpp
     ${XEUS_INCLUDE_DIR}/xeus/xsystem.hpp
+    ${XEUS_INCLUDE_DIR}/xeus/xrequest_context.hpp
 )
 
 set(XEUS_SOURCES
@@ -133,6 +138,7 @@
     ${XEUS_SOURCE_DIR}/xmock_interpreter.hpp
     ${XEUS_SOURCE_DIR}/xserver.cpp
     ${XEUS_SOURCE_DIR}/xsystem.cpp
+    ${XEUS_SOURCE_DIR}/xrequest_context.cpp
 )
 
 # Targets and link
@@ -166,10 +172,9 @@
     target_link_libraries(
         ${target_name}
         PUBLIC nlohmann_json::nlohmann_json
-        PUBLIC xtl
     )
 
-    if (NOT MSVC AND NOT XEUS_EMSCRIPTEN_WASM_BUILD)
+    if (NOT MSVC AND NOT EMSCRIPTEN)
         if (APPLE)
             target_link_libraries(${target_name} PUBLIC "-framework CoreFoundation")
         else ()
@@ -219,7 +224,7 @@
     # Compilation flags
     # =================
 
-    target_compile_features(${target_name} PRIVATE cxx_std_14)
+    target_compile_features(${target_name} PRIVATE cxx_std_17)
     xeus_target_add_compile_warnings(${target_name})
 
     if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
@@ -251,7 +256,7 @@
         endif ()
     endif ()
 
-    if (XEUS_EMSCRIPTEN_WASM_BUILD)
+    if (EMSCRIPTEN)
        target_compile_definitions(${target_name} PRIVATE XEUS_EMSCRIPTEN_WASM_BUILD)
        xeus_wasm_compile_options(${target_name})
     endif()
@@ -324,10 +329,3 @@
                               INSTALL_DESTINATION ${PROJECT_BINARY_DIR})
 
 # Configure 'xeusConfig.cmake' for an install tree
-set(XEUS_CONFIG_CODE "")
-configure_package_config_file(${PROJECT_NAME}Config.cmake.in
-                              "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${PROJECT_NAME}Config.cmake"
-                              INSTALL_DESTINATION ${XEUS_CMAKECONFIG_INSTALL_DIR})
-
-
-write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake

=== debian/changelog ===
xeus (5.1.1-0.1) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * New upstream release
    - New soname: libxeus9 -> libxeus11
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config.
    - New library name: libxeus9 -> libxeus11
  * debian/libxeus9.install: rename to debian/libxeus11.install

 -- Bill Allombert <ballombe@debian.org>  Fri, 27 Dec 2024 11:50:30 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                nlohmann-json3-dev (>= 3.11.3~),
                uuid-dev,
                libssl-dev,
-               pkg-config,
+               pkgconf,
                doctest-dev,
 Standards-Version: 4.6.1
 Section: libs
@@ -17,7 +17,7 @@
 Vcs-Browser: https://salsa.debian.org/science-team/xeus
 Rules-Requires-Root: no
 
-Package: libxeus9
+Package: libxeus11
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: C++ Implementation of the Jupyter Kernel protocol (library)
@@ -31,7 +31,7 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends},
-         libxeus9 (= ${binary:Version}),
+         libxeus11 (= ${binary:Version}),
          xtl-dev,
          nlohmann-json3-dev (>= 3.11.3~),
          uuid-dev,

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus/tags .*/archive/refs/tags/@ANY_VERSION@@ARCHIVE_EXT@
